/* aidepost.c
 * v1.1
 * posts standard input to Aide> room
 * updated to include I (orig sys msg #) field
 */

#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include "citadel.h"
char temp[20];

long lseek();
long atol();

strucmp(st1,st2)
char st1[],st2[];
{
	int a;
	char aaa[100],bbb[100];
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

send_message(filename,retbuf)	/* send a message to the master file */
char filename[];		/* tempfilename of proper message */
struct smreturn *retbuf;	/* return information */
{

int file,a,b,c,d,e,file2;
long aa,bb,cc,dd,ee,templen,hibytes,origpos;
char aaa[100],mid[30];
struct msgmain msgmain;


	file=open("./MMstructure",O_RDWR);
	if (file<0) exit(13);
PWMINS:
	a=read(file,&msgmain,sizeof(struct msgmain));
	if (a<1) exit(14);
	if (msgmain.MMflags & MM_BUSY) {
					 lseek(file,0L,0); goto PWMINS; }

	lseek(file,0L,0);
	msgmain.MMflags=(msgmain.MMflags|MM_BUSY);
	a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) exit(16);
	close(file);
	origpos=msgmain.MMcurpos;
	++msgmain.MMhighest;
	sprintf(mid,"I%ld",msgmain.MMhighest);
/* measure the message */
file=open(filename,O_RDONLY); if (file<0) sprintf(stderr,"aidepost: error\n");
templen=lseek(file,0L,2);
close(file);
templen=templen+(long)strlen(mid);
++templen;

/* check for FF bytes */
hibytes=0L;
file=open("./msgmain",O_RDWR);
if (file<0) fprintf(stderr,"aidepost: can't open msgmain\n");
bb=lseek(file,msgmain.MMcurpos,0);

cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (cc>=MM_FILELEN) cc=lseek(file,0L,0);
	c=0; read(file,&c,1); ++cc;
	if (c>127) ++hibytes;		/* bump count if hi bit set */
	}

msgmain.MMlowest=msgmain.MMlowest+hibytes;

cc=lseek(file,msgmain.MMcurpos,0);

file2=open(filename,O_RDONLY); if (file2<0) exit(19);
cc=lseek(file,0L,1);
read(file2,&b,2);
write(file,&b,2);
read(file2,&b,1);
write(file,&b,1);
write(file,mid,(strlen(mid)+1));
for (bb=0L; bb<templen; ++bb) {
	if (((long)cc)>=((long)MM_FILELEN)) cc=lseek(file,0L,0);
	read(file2,&b,1); 
	write(file,&b,1); ++cc;
	}
msgmain.MMcurpos=lseek(file,0L,1);
close(file2);	/* done with temp file */
close(file);	/* done with master file */


/* now update the message structure */

msgmain.MMflags=msgmain.MMflags & ~MM_BUSY;

file=open("./MMstructure",O_RDWR); if (file<0) printf("20!!!\n");
a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) printf("21!!!\n");
close(file);
retbuf->smnumber=msgmain.MMhighest;
retbuf->smpos=origpos;



return(0);

}

make_message(filename)
char filename[];	/* temporary file name */
{ 
	FILE *fp;
	int a,b,c,old;
	long aa,bb,cc,beg,now;
	char aaa[100],bbb[100]; 
	time(&now);
	fp=fopen(filename,"wb"); if (fp==NULL) exit(22);
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(1,fp);
	fprintf(fp,"T%ld",now); putc(0,fp);
	fprintf(fp,"ASysop"); putc(0,fp);
	fprintf(fp,"OAide"); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp);
	putc('M',fp);
	while ((a=getc(stdin))>0) {
		putc(a,fp);
		}
MEFIN:	putc(0,fp);
	fclose(fp);
	return(0);

}

main(argc,argv)
int argc;
char *argv[];
{
	int file,a,b;
	long aa;
	char aaa[100];
	struct smreturn mybuffer;
	struct quickroom quickroom;
	struct fullroom fullroom;

	sprintf(temp,"/tmp/ap%d",getpid());
	make_message(temp);
	send_message(temp,&mybuffer);
	unlink(temp);

	file=open("./quickroom",O_RDWR);
	b=2;
	lseek(file,(long)(b*sizeof(struct quickroom)),0);
	read(file,&quickroom,sizeof(struct quickroom));
	quickroom.QRhighest=mybuffer.smnumber;
	lseek(file,(long)(b*sizeof(struct quickroom)),0);
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);

	sprintf(aaa,"./rooms/fullrm%d",b);
	file=open(aaa,O_RDWR);
	read(file,&fullroom,sizeof(struct fullroom));
	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=mybuffer.smnumber;
	fullroom.FRpos[MSGSPERRM-1]=mybuffer.smpos;
	lseek(file,0L,0);
	write(file,&fullroom,sizeof(struct fullroom));
	close(file);
	exit(0);
}
