#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <pwd.h>
#include "citadel.h"

/* Citadel/UX sysop utilities.
 * The software assumes that if a user has root access than he/she is
 * allowed to use the sysop utilities. Make sure that the permissions
 * are correct for this.
 */
long atol;
long lseek();

#ifdef BSD
#undef toupper
#undef _toupper
toupper(c)
int c; {return(islower(c)?c-'a'+'A':c);}
#undef tolower
#undef _tolower
tolower(c)
int c; {return(isupper(c)?c-'A'+'a':c);}
#endif BSD


long finduser(file,name)
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);

	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

FPT:	if ((obottom==bottom)&&(otop==top)) {
		return(-1L); }
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0)
		
		return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) {
		bottom=guess;
		goto FPT; }
	if (a>0) {
		top=guess;
		goto FPT; }
}


main(argc,argv) 
int argc;
char *argv[];
{
	int a,b,c,d,e;
	long aa,bb,cc,dd,ee;
	char aaa[100],bbb[100],ccc[100],ddd[100],eee[100];
	struct usersupp usersupp;
	int file;

if (!strcmp(argv[1],"userpurge")) {
	userpurge();
	exit(0);
	}

MAINMENU:
system("clear"); /* Clear screen. Remove if command not available */
printf("\n\n");
printf("Citadel/UX Sysop Utilities\n");
printf(" 1. Give user aide privileges\n");
printf(" 2. Take away aide privileges\n");
printf(" 3. Delete a user\n");
printf(" 4. Unlock message file\n");
printf(" 5. Attach a BBS account to an /etc/passwd account\n");
printf(" 6. Sort the userlog\n");
printf(" 7. Purge old users\n");
printf(" 8. Change casing of a user's name\n");
printf(" 9. List users\n");
printf(" 10. Quit\n");
printf(" Please enter your selection: ");
	gets(aaa);
	a=atoi(aaa);
	if (a==1) goto AIDE;
	if (a==2) goto AIDE;
	if (a==3) deluser();
	if (a==4) unlock();
	if (a==5) attach();
	if (a==6) sortlog("usersupp");
	if (a==7) userpurge();
	if (a==8) renameuser();
	if (a==9) usrlist();
	if (a==10) exit(0);
	goto MAINMENU;

AIDE:	printf("Who ");
	if (a==1) printf("gets ");
	if (a==2) printf("loses ");
	printf("aide privileges? ");
	gets(aaa);
	if (aaa[0]==0) goto MAINMENU;
YNAG:	printf("%s ",aaa);
	if (a==1) printf("gets ");
	if (a==2) printf("loses ");
	printf("aide privileges. Confirm (y/n) -> ");
	gets(bbb);
	bbb[0]=tolower(bbb[0]);
	if (bbb[0]=='n') goto MAINMENU;
	if (bbb[0]!='y') goto YNAG;

/* now find da dude and give/take away his/her aide privileges */

	file=open("usersupp",O_RDWR);
	if (file<0) {
		printf("Something's REALLY wrong...no usersupp file!\n");
		goto MAINMENU;
			}
NSRCHA:	aa=lseek(file,0l,1);
	b=read(file,&usersupp,sizeof(struct usersupp));
	if (b<1) goto YOW;
	if (strucmp(usersupp.fullname,aaa)) goto NSRCHA;
	goto NCHGIT;

YOW:	printf("\nNo such user.\n");
	close(file);
	printf("<press return to continue>");
	gets(aaa);
	goto MAINMENU;

NCHGIT:
	lseek(file,aa,0);
	usersupp.flags=(usersupp.flags|US_AIDE);
	if (a==2) usersupp.flags=usersupp.flags-US_AIDE;
	write(file,&usersupp,sizeof(struct usersupp));
	close(file);

goto MAINMENU;

}

usrlist()
{
char aaa[100];
	system("userlist password");
	printf("<press return to continue>");
	gets(aaa);
}

deluser(argc,argv)
int argc;
char *argv[]; {
int a,b,c,d,file,file2;
char aaa[100];
char dme[100];
struct usersupp usersupp;

printf("Name of user to delete? ");
gets(dme);

file=open("usersupp",O_RDONLY);
if (file<0) {
	printf("No usersupp file available.\n");
	return(1); }
file2=creat("usersupp.new",0666);
if (file<0) {
	printf("Can't open the new file.\n");
	close(file);
	return(2); }
A:	a=read(file,&usersupp,sizeof(struct usersupp));
	if (a<1) goto END;
	if (!strucmp(dme,usersupp.fullname)) goto B;
	b=write(file2,&usersupp,sizeof(struct usersupp));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

B:	printf("%s removed\n",
		usersupp.fullname);
	goto A;

END:	close(file);
	close(file2);
	printf("                                        ");
	printf("                                   \n");
	system("mv usersupp.new usersupp");
	system("chmod 666 usersupp");
	return(0);
}
/* The msgmain file is locked through the MMstructure file during writes,
 * to avoid two processes writing in the same place. If the program crashes
 * while the file is locked, run this program to unlock it.
 */

unlock() {

	struct msgmain msgmain;
	int file,a,b,c;
	FILE *fp;
	long aa,bb,cc,dd,ee;

printf("%s\nUnlocking master message file\n\n",PGMNAME);

fp=fopen("MMstructure","rb");
fread(&msgmain,sizeof(struct msgmain),1,fp);
msgmain.MMflags = msgmain.MMflags & ~MM_BUSY;
fclose(fp);
fp=fopen("MMstructure","wb");

fwrite(&msgmain,sizeof(struct msgmain),1,fp);

fclose(fp);

return(0);
}

attach() {	/* attach a bbs account to an /etc/passwd account */
	struct usersupp usersupp;
	int file,file2,a,b,c,flag;
	char full[100],log[100];

	printf("Enter unix login name: ");
	gets(log);
	printf(" Enter BBS login name: ");
	gets(full);

	flag=0;
	file=open("./usersupp",O_RDONLY);
	file2=creat("./usersupp.new",0666);
	
ATA:	a=read(file,&usersupp,sizeof(struct usersupp));
	if (a<1) goto ATEND;
	if (!strucmp(usersupp.fullname,full)) {
		strcpy(usersupp.logname,log);
		flag=1; }
	write(file2,&usersupp,sizeof(struct usersupp));
	goto ATA;
	
ATEND:	close(file); close(file2);
	if (flag==1) {
		system("mv usersupp.new usersupp");
		system("chmod 666 usersupp");
		printf("ok\n"); }
	if (flag==0) {
		system("rm usersupp.new");
		printf("No such user.\n"); }
	printf("<press return>");
	gets(log);
	return(0);
}
		
sortlog(filename)
char *filename; {
	char aaa[100];
	struct usersupp rec1;
	struct usersupp rec2;
	int file,a,b,c;
	long aa,bb,cc,dd,nrecs;

	system("clear");
	printf("6. Sort the userlog\n");
	printf("--- this will take a long time, and if it is stopped\n");
	printf("before it is finished, the userlog will be screwed up!\n");
	printf("Enter password, or <return> to abort: ");
	gets(aaa);
	if (strucmp(aaa,"ledatic")) return(1);
	sprintf(aaa,"cp %s usersupp.bak",filename);
	system(aaa);
	file=open(filename,O_RDWR);
	if (file<0) return(file);
	aa=lseek(file,0L,2); nrecs=(aa/sizeof(struct usersupp));
	for (cc=0; cc<nrecs; ++cc) {
		printf("Sorted %5d of %5d records.\n",cc,nrecs);
		for (dd=(nrecs-1L); dd>cc; --dd) {
			aa=((dd-1L)*sizeof(struct usersupp));
			lseek(file,aa,0);
			read(file,&rec1,sizeof(struct usersupp));
			read(file,&rec2,sizeof(struct usersupp));
			if (strucmp(rec1.fullname,rec2.fullname)>0) {
				lseek(file,aa,0);
				write(file,&rec2,sizeof(struct usersupp));
				write(file,&rec1,sizeof(struct usersupp));
				}
			}
		}
	close(file);
	return(0);
}

strucmp(st1,st2)
char *st1;
char *st2; {
	char aaa[100],bbb[100];
	int a;
	strcpy(aaa,st1);
	strcpy(bbb,st2);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	for (a=0; a<strlen(bbb); ++a) bbb[a]=tolower(bbb[a]);
	a=strcmp(aaa,bbb);
	return(a);
}
#define CLN (5184000L)

struct passwd *getpwuid();
struct passwd *getpwnam();
struct passwd *passwd;

logname()
{
int a;
char logname[50],fullname[50];

	a=getuid();
	passwd=(struct passwd *)getpwuid(a);
	strcpy(logname,passwd->pw_name);
	strcpy(fullname,passwd->pw_gecos);
#ifdef BSD
	for (a=0; a<strlen(fullname); ++a) if (fullname[a]==';') fullname[a]=0;
#endif BSD
	return(&logname);
}


userpurge() {	/* removes anyone who hasn't called in 2 months */
int a,b,c,d,file,file2;
char aaa[100];
char dme[100];
struct usersupp usersupp;
long now,call;
FILE *post;

post=popen("aidepost","w");
fprintf(post,"Program: sysoputil userpurge() / Shell user = %s\n",logname());
fprintf(post,"The following users have not called in the past %ld seconds\n",
		CLN);
fprintf(post,"and have been purged off the user file:\n");
time(&now);
file=open("usersupp",O_RDONLY);
if (file<0) {
	printf("No usersupp file available.\n");
	return(1); }
file2=creat("usersupp.new",0666);
if (file<0) {
	printf("Can't open the new file.\n");
	close(file);
	return(2); }
A:	a=read(file,&usersupp,sizeof(struct usersupp));
	if (a<1) goto END;
	call=now-(usersupp.lastcall);
	if (call>CLN) goto B;
	b=write(file2,&usersupp,sizeof(struct usersupp));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

B:	printf("%s removed\n",
		usersupp.fullname);
	fprintf(post,"#%-5ld %-30s pw: %s\n",usersupp.eternal,
		usersupp.fullname,usersupp.password);
	goto A;

END:	close(file);
	close(file2);
	pclose(post);
	system("mv usersupp.new usersupp");
	chmod("usersupp",0666);
	return(0);
}

renameuser() {
	long aa;
	int file;
	struct usersupp user;
	char aaa[100];
	long finduser();

	printf("Enter old name: ");
	gets(aaa);
	file=open("usersupp",O_RDWR);
	aa=finduser(file,aaa);
	if (aa==(-1L)) {
		printf("No such user.\n");
		close(file);
		return(0); }
	read(file,&user,sizeof(struct usersupp));
	printf("Enter new name EXACTLY as it should appear: ");
	gets(user.fullname);
	if (strucmp(aaa,user.fullname)) {
		printf("You may only change casing. Rename not allowed\n");
		close(file);
		return(1);
		}

	finduser(file,aaa);
	write(file,&user,sizeof(struct usersupp));
	close(file);
	return(0);
}
