#include <stdio.h>
#include <fcntl.h>
#include "citadel.h"

/* makevote.c
 * compile a vote source code
 */

getstr(file,string)
int file;
char string[]; {
	int a,b,c;
A:	string[0]=0;
	c=0;
B:	b=0; a=read(file,&b,1);
	if (a==0) return(strlen(string));
	if (b==10) return(strlen(string));
	c=strlen(string);
	string[c]=b;
	string[c+1]=0;
	goto B;
}

main(argc,argv)
int argc;
char *argv[];
{
	char aaa[200],bbb[200],ccc[200];
	int a,b,c,d,e,gen;
	int file,infile,outfile;
	int nques;
	int nans[512];
	struct voteinfo voteinfo;

	if (argc<2) {
		printf("usage: makevote sourcename\r\n");
		exit(1); }

	if (argc==2) infile=open(argv[1],O_RDONLY);
	if (argc==1) infile=0;
	if (infile<0) {
		printf("makevote: can't open %s\r\n",argv[1]);
		exit(2); }
	close(infile);

	gen=20;
	file=open("voteinfo",O_RDONLY);
	read(file,&voteinfo,sizeof(struct voteinfo));
	close(file);

	b=(-1);
	for (a=0; a<NVOTES; ++a)
	  if (voteinfo.VIcurrvote[a]==(-1)) b=a;
	if (b==(-1)) {
		printf("All vote slots are in use.\r\n");
		printf("Delete one first.\r\n");
		exit(3); }

	gen=voteinfo.VInextgen;
	++gen; if (gen==32700) gen=15;
	voteinfo.VInextgen=gen;
	voteinfo.VIcurrvote[b]=gen;
	file=creat("voteinfo",0666);
	write(file,&voteinfo,sizeof(struct voteinfo));
	close(file);
	printf("Vote #%d, vote slot %d\r\n",gen,b);

	sprintf(ccc,"./voting/vote%dobj",b);
	sprintf(bbb,"rm %s",ccc); system(bbb);

	printf("Counting questions and answers...\r\n");
	infile=open(argv[1],O_RDONLY);
	getstr(infile,aaa);
	printf("Vote title:\r\n%s\r\n",aaa);
	nques=(-1);

A:	getstr(infile,aaa);
	if (!strcmp(aaa,"@stop")) goto CSTOP;
	if (!strcmp(aaa,"@next")) {
		getstr(infile,aaa);
		++nques; nans[nques]=0; 
		goto A; }
	++nans[nques];
	goto A;

CSTOP:	close(infile);
	++nques;
	printf("%d Questions\n",nques);
	for (a=0; a<nques; ++a)
		printf("Question %2d has %2d answers\n",a+1,nans[a]);

	infile=open(argv[1],O_RDONLY);
	outfile=creat(ccc,0666);
	write(outfile,&gen,2);
	getstr(infile,aaa);
	write(outfile,aaa,200);
	a=0;
	write(outfile,&a,2);
	write(outfile,&nques,2);
	for (a=0; a<nques; ++a) {
		getstr(infile,aaa);
		b=nans[a];
		write(outfile,&b,2);
		getstr(infile,aaa);
		write(outfile,aaa,200);
		for (c=0; c<nans[a]; ++c) {
			e=0;
			getstr(infile,aaa);
			write(outfile,aaa,100);
			write(outfile,&e,2); }
		}
	close(outfile);
	exit(0);
}

